%Burgersystem with periodic boundary conditions

function dydt=LLFFlux(t,y,N)
dydt=zeros(N,1);
global delta
global LevyMatrix
global alpha

b=1;
a=alpha;
c=1;


%flux = 1 gives Burger's
%flux = 2 gives Buckley Leverett with LF Flux
%flux = 3 gives Linear flux
%flux = 4 give Buckley Leverett with Godunov flux
%flux = 5 also gives Buckley Leverett with Godunov flux
flux=3;

switch flux
    case 1
        periodic=1; %Periodic boundry=1, Dirichlet boundry=0
        if periodic==1
            for i=1:N
                if i==1
                    C1=max(abs(min(y(i),y(i+1))),abs(max(y(i),y(i+1))));
                    hfront=0.5*(0.5*(y(i))^2+0.5*(y(i+1))^2-C1*(y(i+1)-y(i)));
                    
                    C2=max(abs(min(y(N),y(i))),abs(max(y(N),y(i))));
                    hback=0.5*(0.5*(y(N))^2+0.5*(y(i))^2-C2*(y(i)-y(N)));
                    dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
                    
                elseif i==N
                    C1=max(abs(min(y(i),y(1))),abs(max(y(i),y(1))));
                    hfront=0.5*(0.5*(y(i))^2+0.5*(y(1))^2-C1*(y(1)-y(i)));
                    
                    C2=max(abs(min(y(i-1),y(i))),abs(max(y(i-1),y(i))));
                    hback=0.5*(0.5*(y(i-1))^2+0.5*(y(i))^2-C2*(y(i)-y(i-1)));
                    dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
                else
                    C1=max(abs(min(y(i),y(i+1))),abs(max(y(i),y(i+1))));
                    hfront=0.5*(0.5*(y(i))^2+0.5*(y(i+1))^2-C1*(y(i+1)-y(i)));
                    
                    C2=max(abs(min(y(i-1),y(i))),abs(max(y(i-1),y(i))));
                    hback=0.5*(0.5*(y(i-1))^2+0.5*(y(i))^2-C2*(y(i)-y(i-1)));
                    dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
                    
                end
            end
        else
            DirichletStart=1;
            DirichletEnd=0;
            for i=1:N
                if i==1
                    c1=max(y(i+1),y(i));
                    c2=max(DirichletStart,y(i));
                    dydt(i,1)=-(delta)^(-1)*0.25*(y(i+1)^2-DirichletStart^2-2*c1*(y(i+1)-y(i))+2*c2*(y(i)-DirichletStart))+b*delta^(1-a)*MA(i,:)*y';
                elseif i==N
                    c1=max(DirichletEnd,y(i));
                    c2=max(y(i-1),y(i));
                    dydt(i,1)=-(delta)^(-1)*0.25*(DirichletEnd^2-y(i-1)^2-2*c1*(DirichletEnd-y(i))+2*c2*(y(i)-y(i-1)))+b*delta^(1-a)*MA(i,:)*y';
                else
                    c1=max(y(i+1),y(i));
                    c2=max(y(i-1),y(i));
                    dydt(i,1)=-(delta)^(-1)*0.25*(y(i+1)^2-y(i-1)^2-2*c1*(y(i+1)-y(i))+2*c2*(y(i)-y(i-1)))+b*delta^(1-a)*MA(i,:)*y';
                end
            end
        end
    case 2
        for i=1:N
            if i==1
                C1=max(abs(min(y(i),y(i+1))),abs(max(y(i),y(i+1))));
                hfront=0.5*(((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))+((4*(y(i+1))^2)/((4*(y(i+1))^2+(1-y(i+1))^2)))-C1*(y(i+1)-y(i)));
                
                C2=max(abs(min(y(N),y(i))),abs(max(y(N),y(i))));
                hback=0.5*(((4*(y(N))^2)/((4*(y(N))^2+(1-y(N))^2)))+((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))-C2*(y(i)-y(N)));
                dydt(i,1)=(1/delta)*(-hfront+hback-b*LevyMatrix(i,:)*y');
                
            elseif i==N
                C1=max(abs(min(y(i),y(1))),abs(max(y(i),y(1))));
                hfront=0.5*(((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))+((4*(y(1))^2)/((4*(y(1))^2+(1-y(1))^2)))-C1*(y(1)-y(i)));
                
                C2=max(abs(min(y(i-1),y(i))),abs(max(y(i-1),y(i))));
                hback=0.5*(((4*(y(i-1))^2)/((4*(y(i-1))^2+(1-y(i-1))^2)))+((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))-C2*(y(i)-y(i-1)));
                dydt(i,1)=(1/delta)*(-hfront+hback-b*LevyMatrix(i,:)*y');
            else
                C1=max(abs(min(y(i),y(i+1))),abs(max(y(i),y(i+1))));
                hfront=0.5*(((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))+((4*(y(i+1))^2)/((4*(y(i+1))^2+(1-y(i+1))^2)))-C1*(y(i+1)-y(i)));
                
                C2=max(abs(min(y(i-1),y(i))),abs(max(y(i-1),y(i))));
                hback=0.5*(((4*(y(i-1))^2)/((4*(y(i-1))^2+(1-y(i-1))^2)))+((4*(y(i))^2)/((4*(y(i))^2+(1-y(i))^2)))-C2*(y(i)-y(i-1)));
                dydt(i,1)=(1/delta)*(-hfront+hback-b*LevyMatrix(i,:)*y');
            end
        end
    case 3
        for i=1:N
            if i==1
                hfront=0.5*(c+abs(c))*(y(i))+0.5*(c-abs(c))*(y(i+1));
                hback=0.5*(c+abs(c))*(y(N))+0.5*(c-abs(c))*(y(i));
                dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
                
            elseif i==N
                hfront=0.5*(c+abs(c))*(y(i))+0.5*(c-abs(c))*(y(1));
                hback=0.5*(c+abs(c))*(y(i-1))+0.5*(c-abs(c))*(y(i));
                dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
            else
                hfront=0.5*(c+abs(c))*(y(i))+0.5*(c-abs(c))*(y(i+1));
                hback=0.5*(c+abs(c))*(y(i-1))+0.5*(c-abs(c))*(y(i));
                dydt(i,1)=(1/delta)*(-(hfront-hback)-b*LevyMatrix(i,:)*y');
                
            end
        end
    case 4
        for i=1:N
            if i==1
                if y(i)<=y(i+1)
                    front=min((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(i+1)^2)/(4*y(i+1)^2+(1-y(i+1))^2));
                else
                    front=max((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(i+1)^2)/(4*y(i+1)^2+(1-y(i+1))^2));
                end
                if y(N)<=y(i)
                    back=min((4*y(N)^2)/(4*y(N)^2+(1-y(N))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                else
                    back=max((4*y(N)^2)/(4*y(N)^2+(1-y(N))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                end
                dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
            elseif i==N
                if y(i)<=y(1)
                    front=min((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(1)^2)/(4*y(1)^2+(1-y(1))^2));
                else
                    front=max((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(1)^2)/(4*y(1)^2+(1-y(1))^2));
                end
                if y(i-1)<=y(i)
                    back=min((4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                else
                    back=max((4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                end
                dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
            else
                if y(i)<=y(i+1)
                    front=min((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(i+1)^2)/(4*y(i+1)^2+(1-y(i+1))^2));
                else
                    front=max((4*y(i)^2)/(4*y(i)^2+(1-y(i))^2),(4*y(i+1)^2)/(4*y(i+1)^2+(1-y(i+1))^2));
                end
                if y(i-1)<=y(i)
                    back=min((4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                else
                    back=max((4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2),(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2));
                end
                dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
            end
        end
    case 5
        for i=1:N
            if i==1
                
                front=(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2);
                
                back=(4*y(N)^2)/(4*y(N)^2+(1-y(N))^2);
                
                dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
            elseif i==N
                
                front=(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2);
                
                back=(4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2);
                
                dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
            else
                
                front=(4*y(i)^2)/(4*y(i)^2+(1-y(i))^2);
                back=(4*y(i-1)^2)/(4*y(i-1)^2+(1-y(i-1))^2);
            end
            dydt(i,1)=-delta^(-1)*(front-back+b*LevyMatrix(i,:)*y');
        end
end
end