%Runge-Kutta TVD numerical integrator for 2'nd and 3'rd order
function [timevector,solutionvector]=RKTVD(ode, time, inits,N, M)
T=time(2);
dt=T/M;
solutionvector=zeros(M,length(inits));
timevector=zeros(M,1);
y=inits;
t=time(1);
solutionvector(1,:)=y;
timevector(1)=t;
%Coefficient tableau for 2nd order
alpha=[1,0;0.5,0.5];
beta=[1,0;0,0.5];
%Coefficient tableau for 3rd order
%alpha=[1,0,0; 3/4,1/4,0;1/3,0,2/3];
%beta=[1,0,0;0,1/4,0;0,0,2/3];

for i=2:M
    k1=alpha(1,1)*y'+beta(1,1)*dt*ode(t,y,N);
    y=alpha(2,1)*y'+beta(2,1)*dt*ode(t,y,N)+alpha(2,2)*k1+beta(2,2)*dt*ode(t,k1',N);
    
    %Third-order intermediate step
    %y=alpha(3,1)*y'+beta(3,1)*dt*ode(t,y,N)+alpha(3,2)*k1+beta(3,2)*dt*ode(t,k1',N)+alpha(3,3)*k2+beta(3,3)*dt*ode(t,k2',N);
    t=t+dt;
    solutionvector(i,:)=y;
    timevector(i)=t;
    y=y';
end
end

%--------------

