%Script for finding the numerical convergence with constant basis
clear
%Create your grid with N elements
p=[10,15,20,30,50,80,120,200,320,500,1000];
teller=0;
global alpha
alpha=0.1;
global delta
global LevyMatrix
for N=p
x=linspace(-10,10,N+1);

delta=abs(x(1)-x(2));
uspace=x(1,1:N)+delta/2;



%Create the amount of timesteps and an endtime
M=10000;
tEnd=2;

%Find the CFL number
delt=tEnd/M;
CFLno=delt/delta;
disp(CFLno);
disp(delta);



%Create the Discretized Levy Matrix using numerical integration
Levy=0;

if Levy
    LevyMatrix=-numLevy2(N,uspace);
else
    LevyMatrix=zeros(N);
end

%Create the weak initial condition vector
uwblock=weakIC(uspace,@block);
uwgauss=weakIC(uspace,@gauss);
uwsgn=weakIC(uspace,@sgn);
uwartan=weakIC(uspace,@artan);
uwsinus=weakIC(uspace,@sinus);
%Run your ODE-system solver
%Options for Solvers RKTVD, RK4 and fEuler
[t1,s1]=RKTVD(@LLFFlux, [0,tEnd], uwgauss,N,M);


%Gauss Lobatto quadrature
%Different weights depending on the number of nodes
weights2=[1,1];
weights3=[1/3,4/3,1/3];
weights4=[1/6,5/6,5/6,1/6];
weights6=[1/15,(14-sqrt(7))/30,(14+sqrt(7))/30,(14+sqrt(7))/30,(14-sqrt(7))/30,1/15];

%Different sets of integration nodes
nodes2=[-1,1];
nodes3=[-1,0,1];
nodes4=[-1,-sqrt(1/5),sqrt(1/5),1];
nodes6=[-1,-sqrt((1/3)+(2*sqrt(7)/21)),-sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)+(2*sqrt(7)/21)),1];
converr=0;
for i=1:N
    for k=1:6
    converr=converr+(delta/2)*weights6(k)*abs(exactgauss((delta/2)*nodes6(k)+uspace(i))-s1(M,i));
    end
end
disp(converr);
teller=teller+1;
errvect(teller)=converr;
end
