%Gauss-Lobatto quadrature
%for approximating the integral, I, of a function, g, over the domain (a,b)
%Nq is the number of quadrature points
function I=quadrature1D(a,b,Nq,g)
c=(b-a)/2; %coefficient used for mapping from (a,b) to (-1,1)
switch Nq
    case 2
        I=(g(a)+g(b))*c;
    case 3
        I=c*((g(b)+g(-2*c+b))/3+4*g(b-c)/3);
    case 4
        I=c*((g(b)+g(-2*c+b))/6+5*(g(c*sqrt(1/5)+b-c)+g(c*-sqrt(1/5)+b-c))/6);
    case 5
        I=c*((g(b)+g(-2*c+b))/10+49*(g(c*sqrt(3/7)+b-c)+g(c*-sqrt(3/7)+b-c))/90+32*g(b-c)/45);
    otherwise
        disp('Enter a valid number of quadrature points(2,3,4,5)')
end
end

        