%The system of ODE's for Burger's equation using Local Lax-Friedrichs Flux
%First order

function dydt=LLFFlux(t,u,N)
dydt=zeros(2*N,1);
global delta
global Levymatrix11
global Levymatrix01
global Levymatrix10
global Levymatrix00
b=1;
u0=u(1:2:end);
u1=u(2:2:end);
xspace=linspace(-10,10,N+1);
uspace=xspace(1,1:N)+delta/2;
for i=1:N
    flux=1;
    switch flux
        case 1
            %u0 system
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)-u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)-u1(i+1))));
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)-u1(i+1))^2-C1*(u0(i+1)-u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)+u1(N),u0(i)-u1(i))),abs(max(u0(N)+u1(N),u0(i)-u1(i))));
                hback=0.5*(0.5*(u0(N)+u1(N))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(N)-u1(N)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1');
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)-u1(1))),abs(max(u0(i)+u1(i),u0(1)-u1(1))));
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(1)-u1(1))^2-C1*(u0(1)-u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)+u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)+u1(i-1),u0(i)-u1(i))));
                hback=0.5*(0.5*(u0(i-1)+u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)-u1(i-1)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1') ;
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)-u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)-u1(i+1))));
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)-u1(i+1))^2-C1*(u0(i+1)-u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)+u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)+u1(i-1),u0(i)-u1(i))));
                hback=0.5*(0.5*(u0(i-1)+u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)-u1(i-1)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1') ;
            end
        case 2 %Buckley leverett
            weights2=[1,1];
            weights3=[1/3,4/3,1/3];
            weights4=[1/6,5/6,5/6,1/6];
            weights6=[1/15,(14-sqrt(7))/30,(14+sqrt(7))/30,(14+sqrt(7))/30,(14-sqrt(7))/30,1/15];
            nodes2=[-1,1];
            nodes3=[-1,0,1];
            nodes4=[-1,-sqrt(1/5),sqrt(1/5),1];
            nodes6=[-1,-sqrt((1/3)+(2*sqrt(7)/21)),-sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)+(2*sqrt(7)/21)),1];
            stiffness=0;
            for k=1:4
                stiffness=stiffness+(2/delta)*weights4(k)*((4*(u0(i)*phi(nodes4(k),uspace(i))+u1(i)*phi1(nodes4(k),uspace(i)))^2)/((4*(u0(i)*phi(nodes4(k),uspace(i))+u1(i)*phi1(nodes4(k),uspace(i)))^2)+(1-(u0(i)*phi(nodes4(k),uspace(i))+u1(i)*phi1(nodes4(k),uspace(i))))^2));
            end
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)-u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)-u1(i+1))));
                hfront=0.5*(((4*(u0(i)+u1(i))^2)/((4*(u0(i)+u1(i))^2+(1-u0(i)-u1(i))^2)))+((4*(u0(i+1)-u1(i+1))^2)/((4*(u0(i+1)-u1(i+1))^2+(1-u0(i+1)+u1(i+1))^2)))-C1*(u0(i+1)-u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)+u1(N),u0(i)-u1(i))),abs(max(u0(N)+u1(N),u0(i)-u1(i))));
                hback=0.5*(((4*(u0(N)+u1(N))^2)/((4*(u0(N)+u1(N))^2+(1-u0(N)-u1(N))^2)))+((4*(u0(i)-u1(i))^2)/((4*(u0(i)-u1(i))^2+(1-u0(i)+u1(i))^2)))-C2*(u0(i)-u1(i)-u0(N)-u1(N)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(stiffness-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1');
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)-u1(1))),abs(max(u0(i)+u1(i),u0(1)-u1(1))));
                hfront=0.5*(((4*(u0(i)+u1(i))^2)/((4*(u0(i)+u1(i))^2+(1-u0(i)-u1(i))^2)))+((4*(u0(1)-u1(1))^2)/((4*(u0(1)-u1(1))^2+(1-u0(1)+u1(1))^2)))-C1*(u0(1)-u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)+u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)+u1(i-1),u0(i)-u1(i))));
                hback=0.5*(((4*(u0(i-1)+u1(i-1))^2)/((4*(u0(i-1)+u1(i-1))^2+(1-u0(i-1)-u1(i-1))^2)))+((4*(u0(i)-u1(i))^2)/((4*(u0(i)-u1(i))^2+(1-u0(i)+u1(i))^2)))-C2*(u0(i)-u1(i)-u0(i-1)-u1(i-1)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(stiffness-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1') ;
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)-u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)-u1(i+1))));
                hfront=0.5*(((4*(u0(i)+u1(i))^2)/((4*(u0(i)+u1(i))^2+(1-u0(i)-u1(i))^2)))+((4*(u0(i+1)-u1(i+1))^2)/((4*(u0(i+1)-u1(i+1))^2+(1-u0(i+1)+u1(i+1))^2)))-C1*(u0(i+1)-u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)+u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)+u1(i-1),u0(i)-u1(i))));
                hback=0.5*(((4*(u0(i-1)+u1(i-1))^2)/((4*(u0(i-1)+u1(i-1))^2+(1-u0(i-1)-u1(i-1))^2)))+((4*(u0(i)-u1(i))^2)/((4*(u0(i)-u1(i))^2+(1-u0(i)+u1(i))^2)))-C2*(u0(i)-u1(i)-u0(i-1)-u1(i-1)));
                dydt(2*i-1,1)=(1/delta)*(-hfront+hback-b*Levymatrix00(i,:)*u0'-b*Levymatrix10(i,:)*u1');
                dydt(2*i,1)=(3/delta)*(stiffness-hfront-hback-b*Levymatrix01(i,:)*u0'-b*Levymatrix11(i,:)*u1') ;
            end
            
            
    end
    
%     %u1 system
%     if i==1
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
%         
%     elseif i==N
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
%     else
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
%     end
end
end
