%Script for solving Burger's equation using piecewise linear elements

clear


%Create your grid with N elements
% for p=1:1

N=101;
M=200;
x=linspace(-10,10,N+1);
global limiting %To turn limiting on or off, 1=on
limiting=1;
global delta
delta=abs(x(1)-x(2));
global alpha
alpha=0.99;
uspace=x(1,1:N)+delta/2;

%Create the weak initial condition vectors
% uw0=u0IC(uspace,@block0);
% uw1=u1IC(uspace,@block1);
uw0=u0IC(uspace,@gauss0);
uw1=u1IC(uspace,@gauss1);
% uw0=u0IC(uspace,@cos0);
% uw1=u1IC(uspace,@cos1);

%LIMITING THE IC
if limiting
for i=1:N
    if i==1
        uw1(i)=minmod([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(N))]);
    elseif i==N
        uw1(i)=minmod([uw1(i),(uw0(1)-uw0(i)),(uw0(i)-uw0(i-1))]);
    else
        uw1(i)=minmod([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(i-1))]);
        
    end
end
end
%Ordering the IC vector where every other value is u0 and u1
uw=[uw0;uw1];
uw=uw(:)';



%Create the amount of timesteps and an endtime

tEnd=2;
delt=tEnd/M;
CFLno=delt/delta;
disp(CFLno);
disp(delta);


global Levymatrix00
global Levymatrix10
global Levymatrix01
global Levymatrix11
Levy=1; %Turn on or off fractional diffusion, having this off greatly reduces the run time
if Levy
Levymatrix11=numLevy11(N);
Levymatrix00=numLevy00(N);
Levymatrix01=numLevy01(N);
Levymatrix10=numLevy10(N);
else
Levymatrix11=zeros(N);
Levymatrix00=zeros(N);
Levymatrix01=zeros(N);
Levymatrix10=zeros(N);
end



%Run your ODE-system solver
%Options for Solvers RKTVD, RK4 and fEuler
[t1,s1]=RKTVD(@LLFFlux, [0,tEnd], uw,N,M);

%Calculate the expanded function u_h


    linGrid=zeros(N,100);
    uh=zeros(N,100);
    figure;
    hold on;
for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(1,1:2:end);
    u1=s1(1,2:2:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1);
    plot(linGrid(i,:),uh(i,:),'g');
end
for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(1*M/4),1:2:end);
    u1=s1(floor(1*M/4),2:2:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1);
    plot(linGrid(i,:),uh(i,:),'m');
end
for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(2*M/4),1:2:end);
    u1=s1(floor(2*M/4),2:2:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1);
    plot(linGrid(i,:),uh(i,:),'b');
end

for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(3*M/4),1:2:end);
    u1=s1(floor(3*M/4),2:2:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1);
    hold on;
    plot(linGrid(i,:),uh(i,:),'k');
end

for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(4*M/4),1:2:end);
    u1=s1(floor(4*M/4),2:2:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1);
    hold on;
    plot(linGrid(i,:),uh(i,:),'r');
end
axis([-2,6,-0.1,1.1])
% z=linspace(uspace(1),uspace(N),N*100-(N-2));
% zsolved=exactSolution(z);
%plot(z,zsolved);
% L1norm=0;
% for i=1:N
%     if uspace(i)<2
%         if u1(i)==0 || -u0(i)/u1(i)>1
%             L1norm=L1norm+abs(u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-(u0(i)*(-u0(i)))/(abs(u1(i))));
%         end
%     elseif uspace(i)<4
%         if u1(i)==0 || (1-u0(i))/u1(i)>1
%             L1norm=L1norm+abs(1-u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-((u0(i)-1)*(1-u0(i)))/(abs(u1(i))));
%         end
%     else
%         if u1(i)==0 || -u0(i)/u1(i)>1
%             L1norm=L1norm+abs(u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-(u0(i)*(-u0(i)))/(abs(u1(i))));
%         end
%     end  
% end
% L1normvector(p)=L1norm;
% deltas(p)=delta;
% Ns(p)=N;
% disp(L1norm)
% 
% end
% plot(deltas,L1normvector);
% figure;
% plot(Ns, L1normvector);



