function [timevector,solutionvector]=RKTVD(ode, time, inits,N, M)
global limiting
T=time(2);
dt=T/M;
solutionvector=zeros(M,length(inits));
timevector=zeros(M,1);
y=inits;
t=time(1);
solutionvector(1,:)=y;
timevector(1)=t;
%Coefficient tableau for 2nd order
% alpha=[1,0;0.5,0.5];
% beta=[1,0;0,0.5];
%Coefficient tableau for 3rd order
alpha=[1,0,0; 3/4,1/4,0;1/3,0,2/3];
beta=[1,0,0;0,1/4,0;0,0,2/3];


for i=2:M
    
    k1=alpha(1,1)*y'+beta(1,1)*dt*ode(t,y,N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        k10=k1(1:2:end);
        k11=k1(2:2:end);    
        
        for j=1:N
            if j==1
                k11(j)=minmod([k11(j),k10(j+1)-k10(j),k10(j)-k10(N)]);
            elseif j==N
                k11(j)=minmod([k11(j),k10(1)-k10(j),k10(j)-k10(j-1)]);
            else
                k11(j)=minmod([k11(j),k10(j+1)-k10(j),k10(j)-k10(j-1)]);
            end
        end
        k1=[k10';k11'];
        k1=k1(:);

    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    k2=alpha(2,1)*y'+beta(2,1)*dt*ode(t,y,N)+alpha(2,2)*k1+beta(2,2)*dt*ode(t,k1',N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        k20=k2(1:2:end);
        k21=k2(2:2:end);
        
        for j=1:N
            if j==1
                k21(j)=minmod([k21(j),k20(j+1)-k20(j),k20(j)-k20(N)]);
            elseif j==N
                k21(j)=minmod([k21(j),k20(1)-k20(j),k20(j)-k20(j-1)]);
            else
                k21(j)=minmod([k21(j),k20(j+1)-k20(j),k20(j)-k20(j-1)]);
            end
        end
        k2=[k20';k21'];
        k2=k2(:);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    %Third-order intermediate step
    y=alpha(3,1)*y'+beta(3,1)*dt*ode(t,y,N)+alpha(3,2)*k1+beta(3,2)*dt*ode(t,k1',N)+alpha(3,3)*k2+beta(3,3)*dt*ode(t,k2',N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        k30=y(1:2:end);
        k31=y(2:2:end);
        
        for j=1:N
            if j==1
                k31(j)=minmod([k31(j),k30(j+1)-k30(j),k30(j)-k30(N)]);
            elseif j==N
                k31(j)=minmod([k31(j),k30(1)-k30(j),k30(j)-k30(j-1)]);
            else
                k31(j)=minmod([k31(j),k30(j+1)-k30(j),k30(j)-k30(j-1)]);
            end
        end
        y=[k30';k31'];
        y=y(:);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    t=t+dt;
    solutionvector(i,:)=y;
    timevector(i)=t;
    y=y';
    
    



end
end

%--------------

