%Script for finding the numerical convergence for linear basis
clear
p=[10,15,20,30,50,80,120,200,320,500,1000];
global limiting %To turn limiting on or off, 1=on
limiting=0;
teller=0;
global alpha
global delta
for N=p

%Create your grid with N elements
% for p=1:1

M=10000;
x=linspace(-10,10,N+1);


delta=abs(x(1)-x(2));

alpha=0.5;
uspace=x(1,1:N)+delta/2;

%Create the weak initial condition vectors
% uw0=u0IC(uspace,@block0);
% uw1=u1IC(uspace,@block1);
uw0=u0IC(uspace,@gauss0);
uw1=u1IC(uspace,@gauss1);
% uw0=u0IC(uspace,@cos0);
% uw1=u1IC(uspace,@cos1);

%LIMITING THE IC
if limiting
for i=1:N
    if i==1
        uw1(i)=minmod([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(N))]);
    elseif i==N
        uw1(i)=minmod([uw1(i),(uw0(1)-uw0(i)),(uw0(i)-uw0(i-1))]);
    else
        uw1(i)=minmod([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(i-1))]);
        
    end
end
end
%Ordering the IC vector where every other value is u0 and u1
uw=[uw0;uw1];
uw=uw(:)';



%Create the amount of timesteps and an endtime

tEnd=2;
delt=tEnd/M;
CFLno=delt/delta;
disp(CFLno);
disp(delta);


global Levymatrix00
global Levymatrix10
global Levymatrix01
global Levymatrix11
Levy=0; %Turn on or off fractional diffusion, having this off greatly reduces the run time
if Levy
Levymatrix11=numLevy11(N);
Levymatrix00=numLevy00(N);
Levymatrix01=numLevy01(N);
Levymatrix10=numLevy10(N);
else
Levymatrix11=zeros(N);
Levymatrix00=zeros(N);
Levymatrix01=zeros(N);
Levymatrix10=zeros(N);
end



%Run your ODE-system solver
%Options for Solvers RKTVD, RK4 and fEuler
[t1,s1]=RKTVD(@linearFlux, [0,tEnd], uw,N,M);

    u0=s1(M,1:2:end);
    u1=s1(M,2:2:end);
%Gauss Lobatto quadrature
%Different weights depending on the number of nodes
weights2=[1,1];
weights3=[1/3,4/3,1/3];
weights4=[1/6,5/6,5/6,1/6];
weights6=[1/15,(14-sqrt(7))/30,(14+sqrt(7))/30,(14+sqrt(7))/30,(14-sqrt(7))/30,1/15];

%Different sets of integration nodes
nodes2=[-1,1];
nodes3=[-1,0,1];
nodes4=[-1,-sqrt(1/5),sqrt(1/5),1];
nodes6=[-1,-sqrt((1/3)+(2*sqrt(7)/21)),-sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)+(2*sqrt(7)/21)),1];
converr=0;
for i=1:N
    for k=1:6
    converr=converr+(delta/2)*weights6(k)*abs(exactSolution((delta/2)*nodes6(k)+uspace(i))-u0(i)-u1(i)*nodes6(k));
    end
end
% disp(converr);
teller=teller+1;
errvect(teller)=converr;
end
%Calculate the expanded function u_h


% z=linspace(uspace(1),uspace(N),N*100-(N-2));
% zsolved=exactSolution(z);
%plot(z,zsolved);
% L1norm=0;
% for i=1:N
%     if uspace(i)<2
%         if u1(i)==0 || -u0(i)/u1(i)>1
%             L1norm=L1norm+abs(u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-(u0(i)*(-u0(i)))/(abs(u1(i))));
%         end
%     elseif uspace(i)<4
%         if u1(i)==0 || (1-u0(i))/u1(i)>1
%             L1norm=L1norm+abs(1-u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-((u0(i)-1)*(1-u0(i)))/(abs(u1(i))));
%         end
%     else
%         if u1(i)==0 || -u0(i)/u1(i)>1
%             L1norm=L1norm+abs(u0(i))*delta;
%         else
%             L1norm=L1norm+(delta/2)*(abs(u1(i))-(u0(i)*(-u0(i)))/(abs(u1(i))));
%         end
%     end  
% end
% L1normvector(p)=L1norm;
% deltas(p)=delta;
% Ns(p)=N;
% disp(L1norm)
% 
% end
% plot(deltas,L1normvector);
% figure;
% plot(Ns, L1normvector);



