%The system of ODE's for Burger's equation using Engqvist-Osher Flux
%First order

function dydt=linearEOFlux(t,u,N)
dydt=zeros(2*N,1);
delta=20/N;
u0=u(1:2:end);
u1=u(2:2:end);

for i=1:N   
    %u0 system
    if i==1
        dydt(2*i-1,1)=-delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)-min(0.5*(u(2*i-1)-u(2*i))^2,0)-max(0.5*(u(2*N-1)-u(2*N))^2,0));
    elseif i==N
        dydt(2*i-1,1)=-delta^(-1)*(min(0.5*(u(1)+u(2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)-min(0.5*(u(2*i-1)-u(2*i))^2,0)-max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
    else
        dydt(2*i-1,1)=-delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)-min(0.5*(u(2*i-1)-u(2*i))^2,0)-max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
    end
    %u1 system
    if i==1
        dydt(2*i,1)=delta^(-1)*(3*u(2*i-1)^2+u(2*i)^2)-3*delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*N-1)-u(2*N))^2,0));
        %Linear test
        dydt(2*i,1)=-3*delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*N-1)-u(2*N))^2,0));
        dydt(2*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
    elseif i==N
        dydt(2*i,1)=delta^(-1)*(3*u(2*i-1)^2+u(2*i)^2)-3*delta^(-1)*(min(0.5*(u(1)+u(2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
        %Linear test
        dydt(2*i,1)=-3*delta^(-1)*(min(0.5*(u(1)+u(2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
        dydt(2*i,1)=minmod([dydt(2*i,1),(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
    else
        dydt(2*i,1)=delta^(-1)*(3*u(2*i-1)^2+u(2*i)^2)-3*delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
        %Linear test
        dydt(2*i,1)=-3*delta^(-1)*(min(0.5*(u(2*i+1)+u(2*i+2))^2,0)+max(0.5*(u(2*i-1)+u(2*i))^2,0)+min(0.5*(u(2*i-1)-u(2*i))^2,0)+max(0.5*(u(2*i-3)-u(2*i-2))^2,0));
        dydt(2*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
    end
end
end