%The system of ODE's for Burger's equation using Local Lax-Friedrichs Flux
%First order

function dydt=LLFFlux(t,u,N)
dydt=zeros(3*N,1);
global delta
u0=u(1:3:end);
u1=u(2:3:end);
u2=u(3:3:end);

for i=1:N
    %u0 system
    if i==1
        C1=max(abs(min(u0(i)+u1(i)+u2(i),u0(i+1)-u1(i+1)+u2(i+1))),abs(max(u0(i)+u1(i)+u2(i),u0(i+1)-u1(i+1)+u2(i+1))));
        hfront=0.5*(0.5*(u0(i)+u1(i)+u2(i))^2+0.5*(u0(i+1)-u1(i+1)+u2(i+1))^2-C1*(u0(i+1)-u1(i+1)+u2(i+1)-u0(i)-u1(i)-u2(i)));
        
        C2=max(abs(min(u0(N)+u1(N)+u2(N),u0(i)-u1(i)+u2(i))),abs(max(u0(N)+u1(N)+u2(N),u0(i)-u1(i)+u2(i))));
        hback=0.5*(0.5*(u0(N)+u1(N)+u2(N))^2+0.5*(u0(i)-u1(i)+u2(i))^2-C2*(u0(i)-u1(i)+u2(i)-u0(N)-u1(N)-u2(N)));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2+(1/5)*u2(i)^2-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*u0(i)*u1(i)+(4/5)*u1(i)*u2(i)-hfront+hback);
        
    elseif i==N
        C1=max(abs(min(u0(i)+u1(i)+u2(i),u0(1)-u1(1)+u2(1))),abs(max(u0(i)+u1(i)+u2(i),u0(1)-u1(1)+u2(1))));
        hfront=0.5*(0.5*(u0(i)+u1(i)+u2(i))^2+0.5*(u0(1)-u1(1)+u2(1))^2-C1*(u0(1)-u1(1)+u2(1)-u0(i)-u1(i)-u2(i)));
        
        C2=max(abs(min(u0(i-1)+u1(i-1)+u2(i-1),u0(i)-u1(i)+u2(i))),abs(max(u0(i-1)+u1(i-1)+u2(i-1),u0(i)-u1(i)+u2(i))));
        hback=0.5*(0.5*(u0(i-1)+u1(i-1)+u2(i-1))^2+0.5*(u0(i)-u1(i)+u2(i))^2-C2*(u0(i)-u1(i)+u2(i)-u0(i-1)-u1(i-1)-u2(i-1)));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2+(1/5)*u2(i)^2-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*u0(i)*u1(i)+(4/5)*u1(i)*u2(i)-hfront+hback);
    else
        C1=max(abs(min(u0(i)+u1(i)+u2(i),u0(i+1)-u1(i+1)+u2(i+1))),abs(max(u0(i)+u1(i)+u2(i),u0(i+1)-u1(i+1)+u2(i+1))));
        hfront=0.5*(0.5*(u0(i)+u1(i)+u2(i))^2+0.5*(u0(i+1)-u1(i+1)+u2(i+1))^2-C1*(u0(i+1)-u1(i+1)+u2(i+1)-u0(i)-u1(i)-u2(i)));
        
        C2=max(abs(min(u0(i-1)+u1(i-1)+u2(i-1),u0(i)-u1(i)+u2(i))),abs(max(u0(i-1)+u1(i-1)+u2(i-1),u0(i)-u1(i)+u2(i))));
        hback=0.5*(0.5*(u0(i-1)+u1(i-1)+u2(i-1))^2+0.5*(u0(i)-u1(i)+u2(i))^2-C2*(u0(i)-u1(i)+u2(i)-u0(i-1)-u1(i-1)-u2(i-1)));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(u0(i)^2+(1/3)*u1(i)^2+(1/5)*u2(i)^2-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*u0(i)*u1(i)+(4/5)*u1(i)*u2(i)-hfront+hback);
    end
    
    
%     %u1 system
%     if i==1
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
%         
%     elseif i==N
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
%     else
%         dydt(2*i,1)=tvbm([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
%     end
end
end
