function [timevector,solutionvector]=RK4(ode, time, inits,N,M)
T=time(2);
dt=T/M;
solutionvector=zeros(M,length(inits));
timevector=zeros(M,1);
y=inits;
t=time(1);
solutionvector(1,:)=y;
timevector(1)=t;
for i=2:M
    
    k1=ode(t,y,N);
    k2=ode(t+dt/2,y+(dt/2)*k1',N);
    k3=ode(t+dt/2,y+(dt/2)*k2',N);
    k4=ode(t+dt,y+dt*k3',N);
    y=y+(dt/6)*(k1'+2*k2'+2*k3'+k4');
    t=t+dt;
    solutionvector(i,:)=y;
    timevector(i)=t;
end
end

%--------------


