function [timevector,solutionvector]=RKTVD(ode, time, inits,N, M)
T=time(2);
dt=T/M;
solutionvector=zeros(M,length(inits));
timevector=zeros(M,1);
y=inits;
t=time(1);
solutionvector(1,:)=y;
timevector(1)=t;
%Coefficient tableau for 2nd order
% alpha=[1,0;0.5,0.5];
% beta=[1,0;0,0.5];
%Coefficient tableau for 3rd order
alpha=[1,0,0; 3/4,1/4,0;1/3,0,2/3];
beta=[1,0,0;0,1/4,0;0,0,2/3];

global limiting

for i=2:M
    
    k1=alpha(1,1)*y'+beta(1,1)*dt*ode(t,y,N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        k10=k1(1:3:end);
        k11=k1(2:3:end);
        k12=k1(3:3:end);
        
        for j=1:N
            if j==1
                uupperk1=k10(j)+tvbm([2*k11(j)+5.5*k12(j),k10(j)-k10(N),k10(j+1)-k10(j)]);
                ulowerk1=k10(j)-tvbm([2*k11(j)-5.5*k12(j),k10(j)-k10(N),k10(j+1)-k10(j)]);
            elseif j==N
                uupperk1=k10(j)+tvbm([2*k11(j)+5.5*k12(j),k10(j)-k10(j-1),k10(1)-k10(j)]);
                ulowerk1=k10(j)-tvbm([2*k11(j)-5.5*k12(j),k10(j)-k10(j-1),k10(1)-k10(j)]);
            else
                uupperk1=k10(j)+tvbm([2*k11(j)+5.5*k12(j),k10(j)-k10(j-1),k10(j+1)-k10(j)]);
                ulowerk1=k10(j)-tvbm([2*k11(j)-5.5*k12(j),k10(j)-k10(j-1),k10(j+1)-k10(j)]);
            end
            
            if uupperk1==(k10(j)+2*k11(j)+5.5*k12(j)) && ulowerk1==(k10(j)-2*k11(j)+5.5*k12(j))
                %set u=v, i.e. k1=k1
            else
                
                %set u0(i)=u0(i);
                if j==1
                    k11(j)=tvbm([k11(j),k10(j+1)-k10(j),k10(j)-k10(N)]);
                elseif j==N
                    k11(j)=tvbm([k11(j),k10(1)-k10(j),k10(j)-k10(j-1)]);
                else
                    k11(j)=tvbm([k11(j),k10(j+1)-k10(j),k10(j)-k10(j-1)]);
                end
                k12(j)=0;
            end
        end
        k1=[k10';k11';k12'];
        k1=k1(:);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    k2=alpha(2,1)*y'+beta(2,1)*dt*ode(t,y,N)+alpha(2,2)*k1+beta(2,2)*dt*ode(t,k1',N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        k20=k2(1:3:end);
        k21=k2(2:3:end);
        k22=k2(3:3:end);
        
        for j=1:N
            if j==1
                uupperk2=k20(j)+tvbm([2*k21(j)+5.5*k22(j),k20(j)-k20(N),k20(j+1)-k20(j)]);
                ulowerk2=k20(j)-tvbm([2*k21(j)-5.5*k22(j),k20(j)-k20(N),k20(j+1)-k20(j)]);
            elseif j==N
                uupperk2=k20(j)+tvbm([2*k21(j)+5.5*k22(j),k20(j)-k20(j-1),k20(1)-k20(j)]);
                ulowerk2=k20(j)-tvbm([2*k21(j)-5.5*k22(j),k20(j)-k20(j-1),k20(1)-k20(j)]);
            else
                uupperk2=k20(j)+tvbm([2*k21(j)+5.5*k22(j),k20(j)-k20(j-1),k20(j+1)-k20(j)]);
                ulowerk2=k20(j)-tvbm([2*k21(j)-5.5*k22(j),k20(j)-k20(j-1),k20(j+1)-k20(j)]);
            end
            
            if uupperk2==(k20(j)+2*k21(j)+5.5*k22(j)) && ulowerk2==(k20(j)-2*k21(j)+5.5*k22(j))
                %set u=v, i.e. k1=k1
            else
                
                %set u0(i)=u0(i);
                if j==1
                    k21(j)=tvbm([k21(j),k20(j+1)-k20(j),k20(j)-k20(N)]);
                elseif j==N
                    k21(j)=tvbm([k21(j),k20(1)-k20(j),k20(j)-k20(j-1)]);
                else
                    k21(j)=tvbm([k21(j),k20(j+1)-k20(j),k20(j)-k20(j-1)]);
                end
                k22(j)=0;
            end
        end
        k2=[k20';k21';k22'];
        k2=k2(:);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    %Third-order intermediate step
    y=alpha(3,1)*y'+beta(3,1)*dt*ode(t,y,N)+alpha(3,2)*k1+beta(3,2)*dt*ode(t,k1',N)+alpha(3,3)*k2+beta(3,3)*dt*ode(t,k2',N);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting==1
        y0=y(1:3:end);
        y1=y(2:3:end);
        y2=y(3:3:end);
        
        for j=1:N
            if j==1
                uuppery=y0(j)+tvbm([2*y1(j)+5.5*y2(j),y0(j)-y0(N),y0(j+1)-y0(j)]);
                ulowery=y0(j)-tvbm([2*y1(j)-5.5*y2(j),y0(j)-y0(N),y0(j+1)-y0(j)]);
            elseif j==N
                uuppery=y0(j)+tvbm([2*y1(j)+5.5*y2(j),y0(j)-y0(j-1),y0(1)-y0(j)]);
                ulowery=y0(j)-tvbm([2*y1(j)-5.5*y2(j),y0(j)-y0(j-1),y0(1)-y0(j)]);
            else
                uuppery=y0(j)+tvbm([2*y1(j)+5.5*y2(j),y0(j)-y0(j-1),y0(j+1)-y0(j)]);
                ulowery=y0(j)-tvbm([2*y1(j)-5.5*y2(j),y0(j)-y0(j-1),y0(j+1)-y0(j)]);
            end
            
            if uuppery==(y0(j)+2*y1(j)+5.5*y2(j)) && ulowery==(y0(j)-2*y1(j)+5.5*y2(j))
                %set u=v, i.e. k1=k1
            else
                
                %set u0(i)=u0(i);
                if j==1
                    y1(j)=tvbm([y1(j),y0(j+1)-y0(j),y0(j)-y0(N)]);
                elseif j==N
                    y1(j)=tvbm([y1(j),y0(1)-y0(j),y0(j)-y0(j-1)]);
                else
                    y1(j)=tvbm([y1(j),y0(j+1)-y0(j),y0(j)-y0(j-1)]);
                end
                y2(j)=0;
                
            end
        end
        y=[y0';y1';y2'];
        y=y(:);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    t=t+dt;
    solutionvector(i,:)=y;
    timevector(i)=t;
    y=y';
    
    



end
end

%--------------

