%Script for calculating the numerical convergence of the quadratic basis

clear
%Create your grid with N elements
p=[10,15,20,30,50,80,120,200,320,500,1000];
global limiting %To turn limiting on or off, 1=on
global delta
limiting=0;
teller=0;
for N=p
M=10000;
x=linspace(-10,10,N+1);

delta=abs(x(1)-x(2));


uspace=x(1,1:N)+delta/2;

%Create the weak initial condition vectors
uw0=u0IC(uspace,@gauss0);
uw1=u1IC(uspace,@gauss1);
uw2=u2IC(uspace,@gauss2);
% uw0=u0IC(uspace,@gauss0);
% uw1=u1IC(uspace,@gauss1);
% uw2=u2IC(uspace,@gauss2);
% uw0=u0IC(uspace,@cos0);
% uw1=u1IC(uspace,@cos1);
% uw2=u2IC(uspace,@cos2);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting
        for j=1:N
            if j==1
                uupperuw=uw0(j)+tvbm([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(N),uw0(j+1)-uw0(j)]);
                uloweruw=uw0(j)-tvbm([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(N),uw0(j+1)-uw0(j)]);
            elseif j==N
                uupperuw=uw0(j)+tvbm([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(j-1),uw0(1)-uw0(j)]);
                uloweruw=uw0(j)-tvbm([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(j-1),uw0(1)-uw0(j)]);
            else
                uupperuw=uw0(j)+tvbm([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(j-1),uw0(j+1)-uw0(j)]);
                uloweruw=uw0(j)-tvbm([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(j-1),uw0(j+1)-uw0(j)]);
            end
            
            if uupperuw==(uw0(j)+2*uw1(j)+5.5*uw2(j)) && uloweruw==(uw0(j)-2*uw1(j)+5.5*uw2(j))
                %set u=v, i.e. k1=k1
            else
                
                %set u0(i)=u0(i);
                if j==1
                    uw1(j)=tvbm([uw1(j),uw0(j+1)-uw0(j),uw0(j)-uw0(N)]);
                elseif j==N
                    uw1(j)=tvbm([uw1(j),uw0(1)-uw0(j),uw0(j)-uw0(j-1)]);
                else
                    uw1(j)=tvbm([uw1(j),uw0(j+1)-uw0(j),uw0(j)-uw0(j-1)]);
                end
                uw2(j)=0;
            end
        end
    end
        uw=[uw0;uw1;uw2];
        uw=uw(:)';
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    


% for i=1:N
%     if i==1
%         uw1(i)=tvbm([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(N))]);
%     elseif i==N
%         uw1(i)=tvbm([uw1(i),(uw0(1)-uw0(i)),(uw0(i)-uw0(i-1))]);
%     else
%         uw1(i)=tvbm([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(i-1))]);
%         
%     end
% end
% %Ordering the IC vector where every other value is u0 and u1
% uw=[uw0;uw1;uw2];
% uw=uw(:)';



%Create the amount of timesteps and an endtime

tEnd=2;
% delt=tEnd/M;
% CFLno=delt/delta;
% disp(CFLno);








%Run your ODE-system solver
%Options for Solvers RKTVD, RK4 and fEuler
%Options for equations, @LLFFlux and @linearFlux
[t1,s1]=RKTVD(@linearFlux, [0,tEnd], uw,N,M);
    u0=s1(M,1:3:end);
    u1=s1(M,2:3:end);
    u2=s1(M,3:3:end);
%Gauss Lobatto quadrature
%Different weights depending on the number of nodes
weights2=[1,1];
weights3=[1/3,4/3,1/3];
weights4=[1/6,5/6,5/6,1/6];
weights6=[1/15,(14-sqrt(7))/30,(14+sqrt(7))/30,(14+sqrt(7))/30,(14-sqrt(7))/30,1/15];

%Different sets of integration nodes
nodes2=[-1,1];
nodes3=[-1,0,1];
nodes4=[-1,-sqrt(1/5),sqrt(1/5),1];
nodes6=[-1,-sqrt((1/3)+(2*sqrt(7)/21)),-sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)-(2*sqrt(7)/21)),sqrt((1/3)+(2*sqrt(7)/21)),1];
converr=0;
for i=1:N
    for k=1:6
    converr=converr+(delta/2)*weights6(k)*abs(exactSolution((delta/2)*nodes6(k)+uspace(i))-u0(i)-u1(i)*nodes6(k)-u2(i)*((6/4)*nodes6(k)^2-0.5));
    end
end
% disp(converr);
teller=teller+1;
errvect(teller)=converr;
end



