%System of ODE solver using Forward Euler

function [timevector,solutionvector]=fEuler(ode, time, inits,N,M)
T=time(2);
dt=T/M;
solutionvector=zeros(M,length(inits));
timevector=zeros(M,1);
y=inits;
t=time(1);
solutionvector(1,:)=y;
timevector(1)=t;

for i=2:M
    y=y'+dt*ode(t,y,N);
    t=t+dt;
    solutionvector(i,:)=y;
    timevector(i)=t;
    y=y';
end
end

