%The system of ODE's for Burger's equation using Local Lax-Friedrichs Flux
%First order

function dydt=linearFlux(t,u,N)
dydt=zeros(3*N,1);
global delta
c=1;
u0=u(1:3:end);
u1=u(2:3:end);
u2=u(3:3:end);


for i=1:N
    if i==1
        hfront=0.5*(c+abs(c))*(u0(i)+u1(i)+u2(i))+0.5*(c-abs(c))*(u0(i+1)-u1(i+1)+u2(i+1));
        hback=0.5*(c+abs(c))*(u0(N)+u1(N)+u2(N))+0.5*(c-abs(c))*(u0(i)-u1(i)+u2(i));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(2*c*u0(i)-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*c*u1(i)-hfront+hback);
    elseif i==N
        hfront=0.5*(c+abs(c))*(u0(i)+u1(i)+u2(i))+0.5*(c-abs(c))*(u0(1)-u1(1)+u2(1));
        hback=0.5*(c+abs(c))*(u0(i-1)+u1(i-1)+u2(i-1))+0.5*(c-abs(c))*(u0(i)-u1(i)+u2(i));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(2*c*u0(i)-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*c*u1(i)-hfront+hback);
    else
        hfront=0.5*(c+abs(c))*(u0(i)+u1(i)+u2(i))+0.5*(c-abs(c))*(u0(i+1)-u1(i+1)+u2(i+1));
        hback=0.5*(c+abs(c))*(u0(i-1)+u1(i-1)+u2(i-1))+0.5*(c-abs(c))*(u0(i)-u1(i)+u2(i));
        dydt(3*i-2,1)=(1/delta)*-(hfront-hback);
        dydt(3*i-1,1)=(3/delta)*(2*c*u0(i)-hfront-hback) ;
        dydt(3*i,1)=(5/delta)*(2*c*u1(i)-hfront+hback);
    end
end

end
