%The system of ODE's for Burger's equation using Local Lax-Friedrichs Flux
%First order

function dydt=linearLLFFlux(t,u,N)
dydt=zeros(2*N,1);
delta=20/N;
c=1;
u0=u(1:2:end);
u1=u(2:2:end);

flux=1;
switch flux
    case 1
        for i=1:N   
            %u0 system
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1; %Use C=1 for Non-Local Lax-Friedrichs flux
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)+u1(i+1))^2-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)-u1(N),u0(i)-u1(i))),abs(max(u0(N)-u1(N),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(N)-u1(N))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(N)+u1(N)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)+u1(1))),abs(max(u0(i)+u1(i),u0(1)+u1(1))));
                %C1=1;
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(1)+u1(1))^2-C1*(u0(1)+u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(i-1)-u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)+u1(i+1))^2-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(i-1)-u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
            end
            %u1 system
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)+u1(i+1))^2-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)-u1(N),u0(i)-u1(i))),abs(max(u0(N)-u1(N),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(N)-u1(N))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(N)+u1(N)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)+u1(1))),abs(max(u0(i)+u1(i),u0(1)+u1(1))));
                %C1=1;
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(1)+u1(1))^2-C1*(u0(1)+u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(i-1)-u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(0.5*(u0(i)+u1(i))^2+0.5*(u0(i+1)+u1(i+1))^2-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(0.5*(u0(i-1)-u1(i-1))^2+0.5*(u0(i)-u1(i))^2-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(3*u0(i)^2+u1(i)^2)+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            end
        end
    case 2
        for i=1:N   
            %u0 system
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1; %Use C=1 for Non-Local Lax-Friedrichs flux
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(i+1)+u1(i+1))-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)-u1(N),u0(i)-u1(i))),abs(max(u0(N)-u1(N),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(N)-u1(N))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(N)+u1(N)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)+u1(1))),abs(max(u0(i)+u1(i),u0(1)+u1(1))));
                %C1=1;
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(1)+u1(1))-C1*(u0(1)+u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(i-1)-u1(i-1))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(i+1)+u1(i+1))-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(i-1)-u1(i-1))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-delta^(-1)*(hfront-hback);
                dydt(2*i-1,1)=h;
            end
            %u1 system
            if i==1
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(i+1)+u1(i+1))-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(N)-u1(N),u0(i)-u1(i))),abs(max(u0(N)-u1(N),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(N)-u1(N))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(N)+u1(N)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(6*c*u0(i))+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
                
            elseif i==N
                C1=max(abs(min(u0(i)+u1(i),u0(1)+u1(1))),abs(max(u0(i)+u1(i),u0(1)+u1(1))));
                %C1=1;
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(1)+u1(1))-C1*(u0(1)+u1(1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(i-1)-u1(i-1))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(6*c*u0(i))+h,(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            else
                C1=max(abs(min(u0(i)+u1(i),u0(i+1)+u1(i+1))),abs(max(u0(i)+u1(i),u0(i+1)+u1(i+1))));
                %C1=1;
                hfront=0.5*(c*(u0(i)+u1(i))+c*(u0(i+1)+u1(i+1))-C1*(u0(i+1)+u1(i+1)-u0(i)-u1(i)));
                
                C2=max(abs(min(u0(i-1)-u1(i-1),u0(i)-u1(i))),abs(max(u0(i-1)-u1(i-1),u0(i)-u1(i))));
                %C2=1;
                hback=0.5*(c*(u0(i-1)-u1(i-1))+c*(u0(i)-u1(i))-C2*(u0(i)-u1(i)-u0(i-1)+u1(i-1)));
                h=-3*delta^(-1)*(hfront+hback);
                dydt(2*i,1)=minmod([delta^(-1)*(6*c*u0(i))+h,(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            end
        end
end
