%The system of ODE's for Burger's equation using Godunov Flux
%First order

function dydt=quadGFlux(t,u,N)
dydt=zeros(2*N,1);
global delta
u0=u(1:2:end);
u1=u(2:2:end);

flux=2;
switch flux
    case 1
        for i=1:N
            %Godunov flux for u_0
            if i==1
                
                dydt(3*i-2,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(N)-u1(N)));
            elseif i==N
                dydt(3*i-2,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(i-1)-u1(i-1)));
            else
                if
                dydt(3*i-2,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(i-1)-u1(i-1)));
            end
            
            %Godunov flux for u_1
            if i==1
                dydt(3*i-1,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(N)-u1(N)));
                dydt(3*i-1,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
            elseif i==N
                dydt(3*i-1,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(3*i-1,1)=minmod([dydt(2*i,1),(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            else
                dydt(3*i-1,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(3*i-1,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            end
            if i==1
                dydt(3*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(N)-u1(N)));
                dydt(3*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
            elseif i==N
                dydt(3*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(3*i,1)=minmod([dydt(2*i,1),(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            else
                dydt(3*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(3*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            end
            
        end
    case 2
        for i=1:N
            %Godunov flux for u_0
            if i==1
                dydt(2*i-1,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(N)-u1(N)));
            elseif i==N
                dydt(2*i-1,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(i-1)-u1(i-1)));
            else
                dydt(2*i-1,1)=-delta^(-1)*(u0(i)+u1(i)-(u0(i-1)-u1(i-1)));
            end
            
            %Godunov flux for u_1
            if i==1
                dydt(2*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(N)-u1(N)));
                dydt(2*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(N))/2]);
            elseif i==N
                dydt(2*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(2*i,1)=minmod([dydt(2*i,1),(u0(1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            else
                dydt(2*i,1)=delta^(-1)*(3*u0(i)^2+u1(i)^2)-3*delta^(-1)*(u0(i)+u1(i)+(u0(i-1)-u1(i-1)));
                dydt(2*i,1)=minmod([dydt(2*i,1),(u0(i+1)-u0(i))/2,(u0(i)-u0(i-1))/2]);
            end
        end
    case 3
        %Do something
end
end


% for i=1:N
%     %Godunov flux for u_0
%     if i==1
%         if (u(2*i-1)+u(2*i))<=(u(2*i+1)+u(2*i+2))
%             front=min((u(2*i-1)+u(2*i))^2,(u(2*i+1)+u(2*i+2))^2);
%         else
%             front=max((u(2*i-1)+u(2*i))^2,(u(2*i+1)+u(2*i+2))^2);
%         end
%         if (u(N-1)+u(N))<=(u(2*i-1)+u(2*i))
%             back=min((u(N-1)-u(N))^2,(u(2*i-1)-u(2*i))^2);
%         else
%             back=max((u(N-1)-u(N))^2,(u(2*i-1)-u(2*i))^2);
%         end
%         dydt(2*i-1,1)=-delta^(-1)*(front-back);
%     elseif i==N
%         if u(i)<=u(1)
%             front=0.5*min(u(i),u(1))^2;
%         else
%             front=0.5*max(u(i),u(1))^2;
%         end
%         if u(i-1)<=u(i)
%             back=0.5*min(u(i-1),u(i))^2;
%         else
%             back=0.5*max(u(i-1),u(i))^2;
%         end
%         dydt(2*i-1,1)=-delta^(-1)*(front-back);
%     else
%         if u(i)<=u(i+1)
%             front=0.5*min(u(i),u(i+1))^2;
%         else
%             front=0.5*max(u(i),u(i+1))^2;
%         end
%         if u(i-1)<=u(i)
%             back=0.5*min(u(i-1),u(i))^2;
%         else
%             back=0.5*max(u(i-1),u(i))^2;
%         end
%         dydt(2*i-1,1)=-delta^(-1)*(front-back);
%     end
%     
%     
%     %Godunov Flux for u_1
%     if i==1
%         if u(i)<=u(i+1)
%             front=min(u(i),u(i+1))^2;
%         else
%             front=max(u(i),u(i+1))^2;
%         end
%         if u(N)<=u(i)
%             back=min(u(N),u(i))^2;
%         else
%             back=max(u(N),u(i))^2;
%         end
%         dydt(2*i,1)=delta^(-1)*(3*u(i)^2+u(i)^2)-3*delta^(-1)*(front+back);
%     elseif i==N
%         if u(i)<=u(1)
%             front=0.5*min(u(i),u(1))^2;
%         else
%             front=0.5*max(u(i),u(1))^2;
%         end
%         if u(i-1)<=u(i)
%             back=0.5*min(u(i-1),u(i))^2;
%         else
%             back=0.5*max(u(i-1),u(i))^2;
%         end
%         dydt(2*i,1)=delta^(-1)*(3*u(i)^2+u(i)^2)-3*delta^(-1)*(front+back);
%     else
%         if u(i)<=u(i+1)
%             front=0.5*min(u(i),u(i+1))^2;
%         else
%             front=0.5*max(u(i),u(i+1))^2;
%         end
%         if u(i-1)<=u(i)
%             back=0.5*min(u(i-1),u(i))^2;
%         else
%             back=0.5*max(u(i-1),u(i))^2;
%         end
%         dydt(2*i,1)=delta^(-1)*(3*u(i)^2+u(i)^2)-3*delta^(-1)*(front+back);
%     end
%     
%     
%     
%     
% end
% end