%Script for solving Burger's equation using piecewise linear elements

clear
%Create your grid with N elements
N=51;
M=100;
x=linspace(-10,10,N+1);
global delta
delta=abs(x(1)-x(2));
global limiting %To turn limiting on or off, 1=on
limiting=1;

uspace=x(1,1:N)+delta/2;

%Create the weak initial condition vectors
uw0=u0IC(uspace,@block0);
uw1=u1IC(uspace,@block1);
uw2=u2IC(uspace,@block2);
% uw0=u0IC(uspace,@gauss0);
% uw1=u1IC(uspace,@gauss1);
% uw2=u2IC(uspace,@gauss2);
% uw0=u0IC(uspace,@cos0);
% uw1=u1IC(uspace,@cos1);
% uw2=u2IC(uspace,@cos2);
    %%%%%%% LIMITING %%%%%%%%%%%%%%%
    if limiting
        for j=1:N
            if j==1
                uupperuw=uw0(j)+minmod([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(N),uw0(j+1)-uw0(j)]);
                uloweruw=uw0(j)-minmod([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(N),uw0(j+1)-uw0(j)]);
            elseif j==N
                uupperuw=uw0(j)+minmod([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(j-1),uw0(1)-uw0(j)]);
                uloweruw=uw0(j)-minmod([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(j-1),uw0(1)-uw0(j)]);
            else
                uupperuw=uw0(j)+minmod([2*uw1(j)+5.5*uw2(j),uw0(j)-uw0(j-1),uw0(j+1)-uw0(j)]);
                uloweruw=uw0(j)-minmod([2*uw1(j)-5.5*uw2(j),uw0(j)-uw0(j-1),uw0(j+1)-uw0(j)]);
            end
            
            if uupperuw==(uw0(j)+2*uw1(j)+5.5*uw2(j)) && uloweruw==(uw0(j)-2*uw1(j)+5.5*uw2(j))
                %set u=v, i.e. k1=k1
            else
                
                %set u0(i)=u0(i);
                if j==1
                    uw1(j)=minmod([uw1(j),uw0(j+1)-uw0(j),uw0(j)-uw0(N)]);
                elseif j==N
                    uw1(j)=minmod([uw1(j),uw0(1)-uw0(j),uw0(j)-uw0(j-1)]);
                else
                    uw1(j)=minmod([uw1(j),uw0(j+1)-uw0(j),uw0(j)-uw0(j-1)]);
                end
                uw2(j)=0;
            end
        end
    end
        uw=[uw0;uw1;uw2];
        uw=uw(:)';
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    


% for i=1:N
%     if i==1
%         uw1(i)=tvbm([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(N))]);
%     elseif i==N
%         uw1(i)=tvbm([uw1(i),(uw0(1)-uw0(i)),(uw0(i)-uw0(i-1))]);
%     else
%         uw1(i)=tvbm([uw1(i),(uw0(i+1)-uw0(i)),(uw0(i)-uw0(i-1))]);
%         
%     end
% end
% %Ordering the IC vector where every other value is u0 and u1
% uw=[uw0;uw1;uw2];
% uw=uw(:)';



%Create the amount of timesteps and an endtime

tEnd=2;
delt=tEnd/M;
CFLno=delt/delta;
disp(CFLno);








%Run your ODE-system solver
%Options for Solvers RKTVD, RK4 and fEuler
%Options for equations, @LLFFlux and @linearFlux
[t1,s1]=RKTVD(@LLFFlux, [0,tEnd], uw,N,M);

%Calculate the expanded function u_h


    linGrid=zeros(N,100);
    uh=zeros(N,100);
    figure;
    hold on;
for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(1,1:3:end);
    u1=s1(1,2:3:end);
    u2=s1(1,3:3:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1)+u2(i)*((6/delta^2)*(linGrid(i,:)-uspace(i)).^2-0.5);
    plot(linGrid(i,:),uh(i,:),'g');
end

for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(1*M/4),1:3:end);
    u1=s1(floor(1*M/4),2:3:end);
    u2=s1(floor(1*M/4),3:3:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1)+u2(i)*((6/delta^2)*(linGrid(i,:)-uspace(i)).^2-0.5);
    hold on;
    plot(linGrid(i,:),uh(i,:),'m');
end

for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(2*M/4),1:3:end);
    u1=s1(floor(2*M/4),2:3:end);
    u2=s1(floor(2*M/4),3:3:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1)+u2(i)*((6/delta^2)*(linGrid(i,:)-uspace(i)).^2-0.5);
    hold on;
    plot(linGrid(i,:),uh(i,:),'b');
end

for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(3*M/4),1:3:end);
    u1=s1(floor(3*M/4),2:3:end);
    u2=s1(floor(3*M/4),3:3:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1)+u2(i)*((6/delta^2)*(linGrid(i,:)-uspace(i)).^2-0.5);
    hold on;
    plot(linGrid(i,:),uh(i,:),'k');
end


for i=1:N
    linGrid(i,:)=linspace(x(i),x(i+1));
    u0=s1(floor(4*M/4),1:3:end);
    u1=s1(floor(4*M/4),2:3:end);
    u2=s1(floor(4*M/4),3:3:end);
    uh(i,:)=u0(i)+u1(i)*2*(linGrid(i,:)-uspace(i))*delta^(-1)+u2(i)*((6/delta^2)*(linGrid(i,:)-uspace(i)).^2-0.5);
    hold on;
    plot(linGrid(i,:),uh(i,:),'r');
end



disp(norm(abs(finalthing-zsolved),1));
axis([-2,6,-0.1,1.1])




